package codelines;

import animation.CodeLine;
import animation.ControlFlow;
import animation.Memory;

public class DefaultForLoop implements CodeLine {

    private boolean initialized = false;
    private Integer i;
    private int start;
    private int max;
    private String vName;
    
    public DefaultForLoop( String vName, int start, int max )
    {
        this.start = start;
        this.max = max;
        this.vName = vName;
    }
    
    @Override
    public ControlFlow runForward(Memory m) {
        if( !initialized )
        {
            initialized = true;
            i = start;
            m.declare( vName, i, false );
        }
        else
        {
            i++;
        }
        if( i > max )
        {
            m.undeclare( vName, false );
            return new ControlFlow( ControlFlow.STEP_OVER );
        }
        else
            return new ControlFlow( ControlFlow.STEP_INTO_LOOP );
    }

    @Override
    public ControlFlow runBackward(Memory m) {
        i--;
        m.declare( vName, i, false );
        if( i < start )
        {
            initialized = false;
            m.undeclare( vName, false );
            return new ControlFlow( ControlFlow.STEP_OVER );
        }
        else
            return new ControlFlow( ControlFlow.STEP_INTO_LOOP );
    }

}
